;
; tactics 0.05 - 30 Apr 2002
;
; by Matt Sephton (matt@ewtoo.org)
;

HidePointer

Global filename$

;init
Dim inputarray(370)
Dim tactics(10,35,2)	;players,segments,x/y

Type filedetails
	Field name$
	Field num
End Type

Type coord
	Field x,y
	Field inplay	;special
End Type

Type player
	Field x#,y#		;current x,y
	Field tx#,ty#		;target x,y
	Field dx#,dy#		;movement x,y
End Type

For p = 0 To 9
	team.player = New player
Next

AppTitle "Select a Tactics file"
Graphics 320,240,32,2
load_tactics()

;draw
Const W = 540, H = 644
Const GW = W/5, GH = H/7
Global M = 3
Global R = 2

Gosub init_players

ball.coord = New coord
ball\x = W/2
ball\y = H/2
ball\inplay = True

AppTitle "Simple Soccer - Tactics " + filename$
Graphics W,H,32,2

SetBuffer BackBuffer()
ClsColor 33,99,0
While Not KeyHit(1)
	Cls
	Color 128,128,128
	Text 0,(GH/2)-18,"Tactics v0.05"
	Text 0,(GH/2)-6,"Simple Soccer"
	Text 8,(GH/2)+6,"30-Apr-2002"

	ball\x = ball\x - (M*KeyDown(203)) + (M*KeyDown(205))
	ball\y = ball\y - (M*KeyDown(200)) + (M*KeyDown(208))

		R = R - KeyHit(26) + KeyHit(27)
		If (R < 1) Then R = 1
		If (R > 5) Then R = 5

		If KeyHit(57) Then	;space
			ball\x = Rand(0,W)
			ball\y = Rand(0,H)
		EndIf
	
		If KeyDown(15) Then	;tab
			count = 0
			where = (ball\x / GW) + (ball\y / GH)*5
			For team.player = Each player
				team\tx = W + ((count+1) * (W/20))
				team\ty = H/2
				team\x = team\tx
				team\y = team\ty
				count = count + 1
			Next
			ball\x = W/2
			ball\y = H/2
			ball\inplay = True
		EndIf
		
		If GetKey() Then ball\inplay = False

	For yc = 0 To 6
		For xc = 0 To 4
			Color 128,128,128
			Text (xc * GW),(yc * GH),(yc*5)+(xc)
			;Color 255,255,255
			Rect (xc * GW)-1, (yc * GH)-1, GW+1,GH+1, False
		Next
	Next

	draw_pitch()

	Color 255,255,0	;255
	Oval ball\x-3, ball\y-3, 7,7, True
	Text ball\x+1,ball\y+1,"B"

	where = (ball\x / GW) + (ball\y / GH)*5
	If (where > 34) Then where = 34

	Color 255,0,0
	count = 0
	For team.player = Each player
		If (ball\inplay = True) Then
			team\tx = (W/2) + (count * 20) + 20
			team\ty = (H/2) - (50-(count*4))
		Else
			team\tx = tactics(count,where,0) * (W/14)
			team\ty = tactics(count,where,1) * (H/15)
		EndIf

		dt# = ATan2(team\ty - team\y, team\tx - team\x)
		
		team\dx = Cos(dt) * R
		team\dy = Sin(dt) * R

		If (near(team\x,team\tx,4) And near(team\y,team\ty,4)) Then
			team\x = team\tx
			team\y = team\ty
			team\dx = 0
			team\dy = 0
		EndIf

		If (team\x > W) Then
			team\x = team\x - R
		Else
			team\x = team\x + team\dx
			team\y = team\y + team\dy
		EndIf

		Line team\x,team\y,team\x+(5*team\dx),team\y+(5*team\dy)
		Oval team\x-3, team\y-3, 7,7, True
		Text team\x+1,team\y+1, count
		count = count+1
	Next

	Text GW/2,0,"R="+R,True

	Flip
Wend

ShowPointer
End

;
.init_players
	count = 0
	For team.player = Each player
		;team\tx = tactics(count,19,0) * (W/14)
		;team\ty = tactics(count,19,1) * (H/15)
		;team\x = team\tx
		;team\y = team\ty
		team\x = W + ((count+1) * (W/20))
		team\y = H/2
		count = count + 1
	Next
Return

Function draw_pitch()
	;WHITE
	Color 255,255,255

	;pen circs
	Oval GW*2.5-GW/2,GH*0.65-GH/2,GW-1,GH,False	;top
	Oval GW*2.5-GW/2,H-GH*0.65-GH/2,GW-1,GH,False	;btm

	;GREEN
	Color 33,99,0
	Rect GW*2,0,GW-1,GH-1,True
	Rect GW*2,H-GH,GW-1,GH,True

	;WHITE
	Color 255,255,255

	Line 0,H/2,W,H/2	;centre
	Oval (W/2)-(GW/2),(H/2)-(GH/2),GW,GH,False	;centre

	;box 1
	Line GW,0,GW,GH-2
	Line GW*4-2,0,GW*4-2,GH-2
	Line GW,GH-2,GW*4-2,GH-2
	;pen 1
	Line GW*2,0,GW*2,GH*0.3
	Line GW*3-2,0,GW*3-2,GH*0.3
	Line GW*2,GH*0.3,GW*3-2,GH*0.3
	Rect GW*2.5-2,GH*0.65-1,3,3

	;box 2
	Line GW,H,GW,H-GH
	Line GW*4-2,H,GW*4-2,H-GH
	Line GW,H-GH,GW*4-2,H-GH
	;pen 2
	Line GW*2,H,GW*2,H-GH*0.3
	Line GW*3-2,H,GW*3-2,H-GH*0.3
	Line GW*2,H-GH*0.3,GW*3-2,H-GH*0.3
	Rect GW*2.5-2,H-GH*0.65-1,3,3

	;corners
	Oval -14,-14,28,28,False
	Oval W-14,-14,28,28,False
	Oval -14,H-14,28,28,False
	Oval W-14,H-14,28,28,False
End Function

Function load_tactics()
	folder$ = ".\data\"
	myDir = ReadDir(folder$)
	
	fcount = 0
	Repeat
		file$ = NextFile$(myDir)
		
		If file$="" Then Exit
		
		If (FileType(folder$+file$) = 1) And (Upper(file$) <> "DEFAULT.TAC") Then
			tac.filedetails = New filedetails
			tac\name = Upper(Left$(file$,Instr(Lower$(file$),".tac")-1))
			tac\num = fcount
			fcount = fcount + 1
		End If
	Forever
	
	pos = 0
	Repeat
		Cls
	
		;Locate 0,0
		c = 0
		For f.filedetails = Each filedetails
			If (pos = c) Then
				Color 255,0,0
			Else
				Color 255,255,255
			EndIf
			If (c = pos) Then
				Text 160,108+(c*12)-(pos*12), "[          ]",True
			EndIf
			Text 160,108+(c*12)-(pos*12), f\name,True
			c = c + 1
		Next
		
		pos = pos - KeyHit(200) + KeyHit(208)
		If (pos < 0) Then pos = 0
		If (pos > fcount -1) Then pos = fcount -1
		
		If KeyHit(1) Then
			pos = -1
			Exit
		EndIf
		
		If KeyHit(28) Then Exit
		
		Flip()
	Forever
	
	CloseDir myDir
	
	c = 0
	For f.filedetails = Each filedetails
		If (c = pos) Then filename$ = f\name
		c = c + 1
	Next

	If (pos = -1) Then filename$ = "DEFAULT"

	;read tactics
	din = ReadFile(folder$ + filename$ + ".tac")
	If (din = 0) Then End ;RuntimeError("FILE")
		For i = 0 To 369
			inputarray(i) = ReadByte(din)
		Next
	CloseFile(din)
	
	;translate
	For i = 0 To 9
		For j = 0 To 34
			intvalue = inputarray( (i*35)+j+9 )
			vertint = intvalue And 15
			horizint = intvalue Shr 4
			tactics(i,j,0) = horizint
			tactics(i,j,1) = vertint
		Next
	Next
	
	FlushKeys()
End Function

Function near(a,b,dist)
	Return (a>b-dist And a<b+dist)
End Function

;